.editor {
  opacity: 1;
  max-height: 100vh;

  .markup.preview {
    a {
      color: $narrojo;
      font-weight: 400;
    }
  }

  &.compressed {
    max-height: 100px;

    .toolbar {
      display: none;
      visibility: hidden;
      opacity: 0;
    }
  }

  &.big-text .canvas {
    .markup,
    .markup.preview * {
      @include font-size(12);
    }
  }

  &[data-editor-style="toolbox"] {
    .toolbar {
      padding-top: 10px;
      @include flexbox(row, nowrap, flex-start, center);

      li {
        margin-bottom: 0;
        margin-right: 10px;
      }
    }

    .canvas {
      max-width: 100%;
      overflow-y: auto;
      max-height: 70vh;
    }

    .markup {
      margin-top: 20px;
    }
  }

  &[data-editor-style="chat"] {
    overflow: visible;
    height: auto;
    @include flex(1 1 auto);

    .toolbar {
      width: auto;
      padding: 0;
      margin-right: 0;
      @include flexbox(row, nowrap, flex-start, center);

      li {
        margin-bottom: 0;
        margin-right: 10px;
      }
    }

    .canvas {
      height: auto;
      display: block;

      &:before {
        display: none;
      }

      .markup {
        height: auto;
        padding: 10px;
        border: 1px solid negro(1);
        background: negro(1);
        @include border-radius(3px);
      }

      textarea {
        max-height: 90px;
      }
    }
  }

  &[data-editor-style="normal"] {
    @include flex(1 1 auto);

    .toolbar {
      width: auto;
      padding: 0;
      margin-right: 0;
      @include flexbox(row, nowrap, flex-start, center);

      li {
        margin-bottom: 0;
        margin-right: 10px;
      }
    }

    .canvas {
      padding: 25px 0 0 0;

      &:before {
        top: 0;
        left: 0;
      }

      .markup {
        padding: 0;
      }

      textarea {
        max-height: 90px;
      }
    }
  }

  .toolbar {
    height: 100%;
    z-index: 1;
    @include box-sizing(content-box);

    li {
      z-index: 0;
      width: 15px;
      height: 15px;
      padding: 5px;
      text-align: center;
      color: $secondary;
      border: 1px solid negro(2);
      cursor: pointer;
      user-select: none; // unselectable
      touch-action: manipulation; // disables tap zoom
      @include border-radius(3px);
      @include font-size(4);
      @include flexbox(row, wrap, center, center);

      &:hover {
        color: $primary;
        background: negro(2);
        border: 1px solid transparent;

        .tooltip {
          @include filter(brightness(130%));
        }
      }

      &[class*="active"] {
        background: #fff;
        color: negro(7);
        border: 1px solid transparent;

        &:hover {
          background: #fff;
          color: negro(7);
          border: 1px solid transparent;
        }
      }

      &:last-child {
        margin-bottom: 0;
      }

      .tooltip {
        display: block;
        width: inherit;
        height: inherit;
        background: transparent;
        @include transition(0.3s all ease-out);

        span {
          width: 100%;
          height: 100%;
        }
      }
    }

    .emoji-picker {
      z-index: 1;

      button {
        cursor: inherit;
      }
    }
  }

  .canvas {
    z-index: 0;
    @include flexbox(row, nowrap, flex-start, stretch);
    @include flex(1 1 auto);

    &:before {
      content: attr(data-title);
      display: block;
      position: absolute;
      color: $secondary;
      line-height: 15px;
      font-weight: 400;
      @include font-size();
    }

    textarea {
      height: auto;
      @include font-size(4);
    }

    .markup {
      width: 100%;
      height: auto;
      background: transparent;
      color: $primary;
      word-wrap: break-word;
      min-height: 100px;
      @include box-sizing(border-box);

      p {
        margin-bottom: 10px;

        // code + code{
        // 	margin-top: 0;
        // 	border-top:0;
        // 	padding-top:0;
        // 	border-top-left-radius: 0;
        // 	border-top-right-radius: 0;
        // }
        &:last-child {
          margin-bottom: 0;
        }
      }

      &,
      p {
        transition: font-size 0.25s ease;
      }
    }
  }
}
